<template>
    <div class="container">
      <v-card flat>
        <v-card-text class="text-h3">Création d'un nouveau deal</v-card-text>
        <v-divider></v-divider>
        <v-form
          ref="form"
          @submit.prevent="submit"
        >
          <v-container fluid>
            <v-row>
              <v-col cols="12">
                <v-text-field
                  v-model="form.title"
                  color="purple darken-2"
                  label="Titre"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-textarea
                  v-model="form.description"
                  color="teal"
                >
                  <template v-slot:label>
                    <div>
                      Description <small>(optional)</small>
                    </div>
                  </template>
                </v-textarea>
              </v-col>
              <v-col cols="6">
                <v-text-field
                  v-model="form.priceOld"
                  color="purple darken-2"
                  label="Prix"
                  type="number"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="6">
                <v-text-field
                  v-model="form.priceNew"
                  color="purple darken-2"
                  label="Nouveau prix"
                  type="number"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  v-model="form.shopName"
                  color="purple darken-2"
                  label="Enseigne"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  v-model="form.shopLink"
                  color="purple darken-2"
                  label="Lien du site"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  v-model="form.promoCode"
                  color="purple darken-2"
                  label="Code promo"
                  required
                ></v-text-field>
              </v-col>
              <v-col cols="12">
                <v-text-field
                  v-model="form.imgURL"
                  color="purple darken-2"
                  label="Lien vers Image"
                  required
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
          <v-card-actions>

            <v-spacer></v-spacer>
            <v-btn
              tile
              @click="resetForm"
              color="primary"
            >
              Reset
            </v-btn>
            <v-btn
              :disabled="!formIsValid"
              tile
              color="primary"
              type="submit"
            >
              Poster
            </v-btn>
          </v-card-actions>
        </v-form>


      </v-card>
    </div>
</template>

<script>
import moment from "moment";

export default {
  name: "PostDeal",
  data () {
    const defaultForm = Object.freeze({
      title: '',
      description: '',
      priceOld: '',
      priceNew: '',
      shopName: '',
      shopLink: '',
      promoCode: '',
      imgURL: '',
    })

    return {
      form: Object.assign({}, defaultForm),
      defaultForm,
    }
  },

  computed: {
    formIsValid () {
      return (
          this.form.title &&
          this.form.priceNew &&
          this.form.shopName &&
          this.form.shopLink &&
            this.form.imgURL
      )
    },
  },

  methods: {
    resetForm () {
      this.form = Object.assign({}, this.defaultForm)
      this.$refs.form.reset()
    },
    submit () {
      const post = this.form
      console.log(post.promoCode)
      this.$axios.post("http://localhost:8080/deals", post, {crossdomain: false })
      .then(
        window.location.replace("/")
      )

    },
  },
}
</script>

<style>

.container {
  justify-content: center;
  align-items: center;
}

</style>
